#!/usr/bin/env perl

use Data::Dumper;
use DBI;
use POSIX qw/strftime/;
use Encode;
use Encode::Guess;

$cnt = 0;  # sikeres INSERT
$ecnt = 0; # adatbazis hibak
$new = 0;  # uj bejegyzesek
$dbname = $ARGV[0];
$status = $ARGV[1];
$source = $ARGV[2];


$db = DBI->connect("DBI:mysql:dbname=$dbname", (getpwuid $<)[0], undef, {AutoCommit=>0, PrintError=>1});

DOMAIN:
while(<STDIN>)
{
	if(m/^<tr><td.*?>[0-9]+/)
	{
		@F = split /\s*<.*?>\s*/;
		#die Dumper $_, \@F;
		undef $domain;
		undef $igenylo;
		undef $reg;

		undef $domainid;
		undef $igenyloid;
		undef $regid;
		undef $statusid;
		undef $sourceid;
		
		$domain = $F[4];
		if($F[8] =~ /^\d\d\d\d-\d\d-\d\d/)
		{
			# domain, igenylo, datum tablazat
			# 2006 nov.-tol nincs kint a regisztrator neve
			$igenylo = $F[6];
			$datum = $F[8];
		}
		elsif($F[6] =~ /^\d\d\d\d-\d\d-\d\d$/)
		{
			# csak domain - datum tablazat
			$datum = $F[6];
		}
		else
		{
			# domain, igenylo, regisztrator, felszabadulas-datum tablazat
			$igenylo = $F[6];
			$reg = $F[8];
			$datum = $F[10];
		}
		
		if($datum =~ /^(\d{4})-(\d\d)-(\d\d) (\d\d):(\d\d):(\d\d)$/)
		{
			$datum = strftime("%s", $6, $5, $4, $3, $2-1, $1-1900);
		}
		elsif($datum =~ /^(\d{4})-(\d\d)-(\d\d)$/)
		{
			$datum = strftime("%s", 0, 0, 0, $3, $2-1, $1-1900);
		}

		#die Dumper $datum, $domain, $igenylo, $reg;
		
		for my $ent (qw/domain igenylo reg status source/)
		{
			$entid = $ent."id";
			$$entid = undef;
			next unless defined $$ent;
			
			my $enc = guess_encoding($$ent, qw/utf8 latin2/);
			if(ref $enc)
			{
				$$ent = encode("utf8", $enc->decode($$ent));
			}
			elsif($enc eq 'iso-8859-2 or utf8')
			{
				1;
			}
			else
			{
				print STDERR "Encoding error: $$ent\n";
				$ecnt++;
				next DOMAIN;
			}
			
			$ok = $db->do("INSERT IGNORE INTO $ent ($ent) VALUES (?)", undef, $$ent);
			if(not defined $ok)
			{
				print STDERR $db->errstr."\n";
				$ecnt++;
				next DOMAIN;
			}

			($$entid) = $db->selectrow_array("SELECT $entid FROM $ent WHERE $ent = ?", undef, $$ent);
			if(!$$entid)
			{
				#print STDERR Dumper "SELECT $entid FROM $ent WHERE $ent = ?", undef, $$ent;
				print STDERR $db->errstr."\n";
				$ecnt++;
				next DOMAIN;
			}
		}
		
		#print STDERR "INSERT: $domainid, $igenyloid, $regid, $datum, $statusid, $sourceid\n";
		$rows = $db->do("INSERT IGNORE INTO hureg (datum, domainid, statusid, igenyloid, regid, sourceid) VALUES (?, ?, ?, ?, ?, ?)", undef, $datum, $domainid, $statusid, $igenyloid, $regid, $sourceid);
		if(defined $rows)
		{
			$cnt++;
			if($rows>0)
			{
				$new++;
			}
		}
		else
		{
			print STDERR $db->errstr."\n";
			$ecnt++;
		}
	}
}

$ok = $db->commit;
if($ok)
{
	print "Domains processed: $cnt, new: $new, status: $status, source: $source\n";
}
else
{
	die "SQL: ".$db->errstr."\n";
}

if($ecnt)
{
	exit 1;
}
else
{
	exit 0;
}
